<template>
    <BasicLayout>
        <template #wrapper>
            <el-card class="box-card">
                <el-form ref="queryForm" :model="queryParams" :inline="true" label-width="68px">
                    <el-form-item label="分组" prop="groupId">
                        <el-select v-model="queryParams.groupId" placeholder="请选择分组" clearable size="small">
                            <el-option label="未分组" :value="-1"></el-option>
                            <el-option v-for="item in groupOptions" :key="'group' + item.value" :label="item.label"
                                :value="item.value">
                            </el-option>
                        </el-select>
                    </el-form-item>
                    <el-form-item label="类型" prop="type">
                        <el-select v-model="queryParams.type" placeholder="请选择类型" clearable size="small">
                            <el-option v-for="item in typeOptions" :key="'type' + item.value" :label="item.label"
                                :value="item.value"></el-option>
                        </el-select>
                    </el-form-item>
                    <el-form-item label="关键字" prop="content"><el-input v-model="queryParams.content"
                            placeholder="请输入关键字" clearable size="small" />
                    </el-form-item>
                    <el-form-item>
                        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
                        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
                    </el-form-item>
                </el-form>

                <el-row :gutter="10" class="mb8">
                    <!-- <el-col :span="1.5">
                        <el-button v-permisaction="['admin:mmRiskLog:add']" type="primary" icon="el-icon-plus"
                            size="mini" @click="handleAdd">新增
                        </el-button>
                    </el-col>
                    <el-col :span="1.5">
                        <el-button v-permisaction="['admin:mmRiskLog:edit']" type="success" icon="el-icon-edit"
                            size="mini" :disabled="single" @click="handleUpdate">修改
                        </el-button>
                    </el-col> -->

                    <el-col :span="1.5">
                        <el-button v-permisaction="['admin:mmRiskLog:remove']" type="danger" icon="el-icon-delete"
                            size="mini" :disabled="multiple" @click="handleDelete">删除
                        </el-button>
                    </el-col>

                    <el-col :span="1.5">
                        <el-popconfirm title="确定清除所有数据?" @confirm="handleClearAll">
                            <el-button slot="reference" v-permisaction="['admin:mmRiskLog:clearAll']" type="danger"
                                icon="el-icon-delete" size="mini">清除全部
                            </el-button>
                        </el-popconfirm>
                    </el-col>
                </el-row>

                <el-table v-loading="loading" :data="mmRiskLogList" @selection-change="handleSelectionChange">
                    <el-table-column type="selection" width="55" align="center" />
                    <el-table-column label="设备Id" prop="machineId" align="center" width="160px"></el-table-column>
                    <el-table-column label="分组" width="120" align="center" prop="groupId" :show-overflow-tooltip="true">
                        <template slot-scope="scope">
                            {{ groupFormat(scope.row.groupId) }}
                        </template>
                    </el-table-column>
                    <el-table-column label="设备唯一标识" prop="biosId" align="center" width="200px"></el-table-column>
                    <el-table-column label="类型" prop="type" align="center">
                        <template slot-scope="scope">
                            {{ typeFormate(scope.row.type) }}
                        </template>
                    </el-table-column>
                    <el-table-column label="关键字" prop="content" align="center"></el-table-column>
                    <el-table-column label="创建时间" align="center" prop="createdAt" width="155px" sortable="custom">
                        <template slot-scope="scope">
                            <span>{{ parseTime(scope.row.createdAt) }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
                        <template slot-scope="scope">
                            <!-- <el-popconfirm class="delete-popconfirm" title="确认要修改吗?" confirm-button-text="修改"
                                @confirm="handleUpdate(scope.row)">
                                <el-button slot="reference" v-permisaction="['admin:mmRiskLog:edit']" size="mini"
                                    type="text" icon="el-icon-edit">修改
                                </el-button>
                            </el-popconfirm> -->
                            <el-popconfirm class="delete-popconfirm" title="确认要删除吗?" confirm-button-text="删除"
                                @confirm="handleDelete(scope.row)">
                                <el-button slot="reference" v-permisaction="['admin:mmRiskLog:remove']" size="mini"
                                    type="text" icon="el-icon-delete">删除
                                </el-button>
                            </el-popconfirm>
                        </template>
                    </el-table-column>
                </el-table>

                <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageIndex"
                    :limit.sync="queryParams.pageSize" @pagination="getList" />

                <!-- 添加或修改对话框 -->
                <el-dialog :title="title" :visible.sync="open" width="500px">
                    <el-form ref="form" :model="form" :rules="rules" label-width="80px">

                        <el-form-item label="类型 0-关键字 1-长度限制" prop="type">
                            <el-input v-model="form.type" placeholder="类型 0-关键字 1-长度限制" />
                        </el-form-item>
                        <el-form-item label="内容" prop="content">
                            <el-input v-model="form.content" placeholder="内容" />
                        </el-form-item>
                    </el-form>
                    <div slot="footer" class="dialog-footer">
                        <el-button type="primary" @click="submitForm">确 定</el-button>
                        <el-button @click="cancel">取 消</el-button>
                    </div>
                </el-dialog>
            </el-card>
        </template>
    </BasicLayout>
</template>

<script>
import { addMmRiskLog, delMmRiskLog, getMmRiskLog, listMmRiskLog, updateMmRiskLog, clearAllMmRiskLog } from '@/api/admin/mm-risk-log'
import { getMmGroupOptions } from '@/api/admin/mm-group'

export default {
    name: 'MmRiskLog',
    components: {
    },
    data() {
        return {
            // 遮罩层
            loading: true,
            // 选中数组
            ids: [],
            // 非单个禁用
            single: true,
            // 非多个禁用
            multiple: true,
            // 总条数
            total: 0,
            // 弹出层标题
            title: '',
            // 是否显示弹出层
            open: false,
            isEdit: false,
            // 类型数据字典
            typeOptions: [{
                label: '关键字',
                value: 0
            }, {
                label: '长度限制',
                value: 1
            }, {
                label: '长度限制(省略符号)',
                value: 2
            }],
            groupOptions: [],
            mmRiskLogList: [],

            // 关系表类型

            // 查询参数
            queryParams: {
                content: '',
                pageIndex: 1,
                pageSize: 10,
                groupId: undefined,
                type:undefined,
                idOrder: 'desc'
            },
            // 表单参数
            form: {
            },
            // 表单校验
            rules: {}
        }
    },
    created() {
        this.getGroupOptions()
        this.getList()
    },
    methods: {
        /** 查询参数列表 */
        getList() {
            this.loading = true
            if (this.queryParams.type===''||this.queryParams.type===null){
                this.queryParams.type=undefined
            }

            listMmRiskLog(this.addDateRange(this.queryParams, this.dateRange)).then(response => {
                this.mmRiskLogList = response.data.list
                this.total = response.data.count
                this.loading = false
            }
            )
        },
        /* 获取分组信息 */
        getGroupOptions() {
            getMmGroupOptions().then(response => {
                this.groupOptions = response.data
            })
        },
        groupFormat(val) {
            let group = this.groupOptions.find(item => item.value === val)

            return group ? group.label : ''
        },
        typeFormate(val) {
            if (!Array.isArray(this.typeOptions)) {
                return '';
            }

            let type = this.typeOptions.find(item => item.value === val)

            return type && type.label ? type.label : '';
        },
        // 取消按钮
        cancel() {
            this.open = false
            this.reset()
        },
        // 表单重置
        reset() {
            this.form = {

                id: undefined,
                type: undefined,
                content: undefined,
            }
            this.resetForm('form')
        },
        getImgList: function () {
            this.form[this.fileIndex] = this.$refs['fileChoose'].resultList[0].fullUrl
        },
        fileClose: function () {
            this.fileOpen = false
        },
        // 关系
        // 文件
        /** 搜索按钮操作 */
        handleQuery() {
            this.queryParams.pageIndex = 1
            this.getList()
        },
        /** 重置按钮操作 */
        resetQuery() {
            this.dateRange = []
            this.resetForm('queryForm')
            this.handleQuery()
        },
        /** 新增按钮操作 */
        handleAdd() {
            this.reset()
            this.open = true
            this.title = '添加设备风险记录'
            this.isEdit = false
        },
        // 多选框选中数据
        handleSelectionChange(selection) {
            this.ids = selection.map(item => item.id)
            this.single = selection.length !== 1
            this.multiple = !selection.length
        },
        /** 修改按钮操作 */
        handleUpdate(row) {
            this.reset()
            const id =
                row.id || this.ids
            getMmRiskLog(id).then(response => {
                this.form = response.data
                this.open = true
                this.title = '修改设备风险记录'
                this.isEdit = true
            })
        },
        /** 提交按钮 */
        submitForm: function () {
            this.$refs['form'].validate(valid => {
                if (valid) {
                    if (this.form.id !== undefined) {
                        updateMmRiskLog(this.form).then(response => {
                            if (response.code === 200) {
                                this.msgSuccess(response.msg)
                                this.open = false
                                this.getList()
                            } else {
                                this.msgError(response.msg)
                            }
                        })
                    } else {
                        addMmRiskLog(this.form).then(response => {
                            if (response.code === 200) {
                                this.msgSuccess(response.msg)
                                this.open = false
                                this.getList()
                            } else {
                                this.msgError(response.msg)
                            }
                        })
                    }
                }
            })
        },
        /** 删除按钮操作 */
        handleDelete(row) {
            var Ids = (row.id && [row.id]) || this.ids

            this.$confirm('是否确认删除编号为"' + Ids + '"的数据项?', '警告', {
                confirmButtonText: '确定',
                cancelButtonText: '取消',
                type: 'warning'
            }).then(function () {
                return delMmRiskLog({ 'ids': Ids })
            }).then((response) => {
                if (response.code === 200) {
                    this.msgSuccess(response.msg)
                    this.open = false
                    this.getList()
                } else {
                    this.msgError(response.msg)
                }
            }).catch(function () {
            })
        },
        handleClearAll() {
            this.loading = true
            clearAllMmRiskLog().then(response => {
                if (response.code === 200) {
                    this.msgSuccess(response.msg)
                    this.getList()
                } else {
                    this.msgError(response.msg)
                }
            }).finally(() => {
                this.loading = false
            })
        }
    }
}
</script>
